unit FVerInfo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ExtCtrls;

type
  TVersionInfo = class(TComponent)
  private
    { Private declarations }
    Ready:Boolean;
    FMainVersion:String;
    FBuild:String;
    FCompanyName:String;
    FFileDescription:String;
    FFileVersion:String;
    FInternalName:String;
    FLegalCopyright:String;
    FLegalTrademarks:String;
    FOriginalFilename:String;
    FProductName:String;
    FProductVersion:String;
    FComments:String;
  protected
    { Protected declarations }
    Constructor Create(AOwner: TComponent);Override;
  public
    { Public declarations }
  published
    { Published declarations }
    Property MainVersion:String read FMainVersion;
    Property Build:String read FBuild;
    Property CompanyName:String read FCompanyName;
    Property FileDescription:String read FFileDescription;
    Property FileVersion:String read FFileVersion;
    Property InternalName:String read FInternalName;
    Property LegalCopyright:String read FLegalCopyright;
    Property LegalTrademarks:String read FLegalTrademarks;
    Property OriginalFilename:String read FOriginalFilename;
    Property ProductName:String read FProductName;
    Property ProductVersion:String read FProductVersion;
    Property Comments:String read FComments;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TVersionInfo]);
end;

Constructor TVersionInfo.Create(AOwner: TComponent);
var
  VerBuf, VerText: String;
  VerSize:Integer;
  Temp:Integer;
Begin
  inherited Create(AOwner);
  VerSize:=GetFileVersionInfoSize(PChar(Application.ExeName),Temp);
  if (VerSize<>0) then begin
    SetLength(VerBuf,VerSize);
    VerText:='';
    SetLength(VerText,VerSize);
    GetFileVersionInfo(PChar(Application.Exename),Temp,VerSize,PChar(VerBuf));
    VerQueryValue(PChar(VerBuf),'\StringFileInfo\041904E3\CompanyName',Pointer(VerText),VerSize);
    FCompanyName:=Copy(VerText,1,VerSize-1);
    VerQueryValue(PChar(VerBuf),'\StringFileInfo\041904E3\FileDescription',Pointer(VerText),VerSize);
    FFileDescription:=Copy(VerText,1,VerSize-1);
    VerQueryValue(PChar(VerBuf),'\StringFileInfo\041904E3\FileVersion',Pointer(VerText),VerSize);
    FFileVersion:=Copy(VerText,1,VerSize-1);
    FMainVersion:=Copy(VerText,1,Pos('.',VerText));
    VerText:=Copy(VerText,Pos('.',VerText)+1,100);
    FMainVersion:=FMainVersion+Copy(VerText,1,Pos('.',VerText)-1);
    FBuild:=Copy(VerText,Pos('.',VerText)+1,100);
    VerQueryValue(PChar(VerBuf),'\StringFileInfo\041904E3\InternalName',Pointer(VerText),VerSize);
    FInternalName:=Copy(VerText,1,VerSize-1);
    VerQueryValue(PChar(VerBuf),'\StringFileInfo\041904E3\LegalCopyright',Pointer(VerText),VerSize);
    FLegalCopyright:=Copy(VerText,1,VerSize-1);
    VerQueryValue(PChar(VerBuf),'\StringFileInfo\041904E3\LegalTrademarks',Pointer(VerText),VerSize);
    FLegalTrademarks:=Copy(VerText,1,VerSize-1);
    VerQueryValue(PChar(VerBuf),'\StringFileInfo\041904E3\OriginalFilename',Pointer(VerText),VerSize);
    FOriginalFilename:=Copy(VerText,1,VerSize-1);
    VerQueryValue(PChar(VerBuf),'\StringFileInfo\041904E3\ProductName',Pointer(VerText),VerSize);
    FProductName:=Copy(VerText,1,VerSize-1);
    VerQueryValue(PChar(VerBuf),'\StringFileInfo\041904E3\ProductVersion',Pointer(VerText),VerSize);
    FProductVersion:=Copy(VerText,1,VerSize-1);
    VerQueryValue(PChar(VerBuf),'\StringFileInfo\041904E3\Comments',Pointer(VerText),VerSize);
    FComments:=Copy(VerText,1,VerSize-1);
  end;
End;

end.
