unit MudRoom;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, ExtCtrls, Forms, Dialogs, BitmapPanel;

type
  TMudRoom2 = class(TComponent)
  private
    { Private declarations }
    fExits:String;
    fHint:String;
    fUp:Byte;
    fDown:Byte;
    fNorth:Byte;
    fSouth:Byte;
    fWest:Byte;
    fEast:Byte;
    fChU:Boolean;
    fChD:Boolean;
    fChN:Boolean;
    fChS:Boolean;
    fChW:Boolean;
    fChE:Boolean;
    fBColor:TColor;
    fDescription:String;
    fNote:String;
    fQuickList:String;
    fX:Integer;
    fY:Integer;
    fL:Integer;
    fDX:Integer;
    fDY:Integer;
    fDL:Integer;
    fSelected:Boolean;
    fChecked:Boolean;
    fPipe:Boolean;
    fAutoMaps:TStringList;
    fDT:Boolean;
    fFlyDT:Boolean;
    fAgro:Boolean;
    fNoStep:Boolean;
    fImageIndex:Integer;
  protected
    { Protected declarations }
    procedure SetExits(Value:String);
  public
    { Public declarations }
    procedure PaintSelf(Canvas:TCanvas);
    procedure SetSelected(Value:Boolean);
    procedure SetChecked(Value:Boolean);
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    { Published declarations }
    Property Exits:String read fExits write SetExits;
    Property Hint:String read fHint write fHint;
    Property ChN:Boolean read fChN write fChN;
    Property ChS:Boolean read fChS write fChS;
    Property ChW:Boolean read fChW write fChW;
    Property ChE:Boolean read fChE write fChE;
    Property ChU:Boolean read fChU write fChU;
    Property ChD:Boolean read fChD write fChD;
    Property BColor:TColor read fBColor write fBColor default clSilver;
    Property Description:String read fDescription write fDescription;
    Property X:Integer read fX write fX;
    Property Y:Integer read fY write fY;
    Property L:Integer read fL write fL;
    Property DX:Integer read fDX write fDX;
    Property DY:Integer read fDY write fDY;
    Property DL:Integer read fDL write fDL;
    Property Selected:Boolean read fSelected write SetSelected default False;
    Property Checked:Boolean read fChecked write SetChecked default False;
    Property Pipe:Boolean read fPipe write fPipe default False;
    Property DT:Boolean read fDT write fDT default False;
    Property FlyDT:Boolean read fFlyDT write fFlyDT default False;
    Property Agro:Boolean read fAgro write fAgro default False;
    Property NoStep:Boolean read fNoStep write fNoStep default False;
    Property Note:String read fNote write fNote;
    Property QuickList:String read fQuickList write fQuickList;
    Property AutoMaps:TStringList read fAutoMaps write fAutoMaps;
    Property ImageIndex:Integer read fImageIndex write fImageIndex default 0;
  end;
implementation

uses Unit1;

constructor TMudRoom2.Create(AOwner: TComponent);
begin
  inherited;
  fAutoMaps:=TStringList.Create;
  fImageIndex:=0;
end;

destructor TMudRoom2.Destroy;
begin
  fAutoMaps.Destroy;
  inherited;
end;

function iif(Cond:Boolean; X:Variant; Y:Variant):Variant;
begin
  if Cond then Result:=X else Result:=y;
end;

function Token(nom:Integer;s,delim:String):String;
var s1:String;
    p,n:Integer;
begin
  s1:=s;
  n:=nom;
  repeat
    p:=Pos(delim,s1);
    if p>0 then result:=Copy(s1,1,p-1)
           else result:=s1;
    if p>0 then s1:=Copy(s1,p+Length(delim),Length(s1)-p-Length(Delim)+1)
           else s1:='';
    dec(n);
  until n=0;
end;

procedure TMudRoom2.SetSelected(Value:Boolean);
begin
   fSelected:=Value;
end;

procedure TMudRoom2.SetChecked(Value:Boolean);
begin
   fChecked:=Value;
end;

procedure TMudRoom2.SetExits(Value:String);
begin
  fExits:=Value;
  if Pos(MudMapperForm.sEast,fExits)>0 then if Pos('('+MudMapperForm.sEast+')',fExits)>0 then fEast:=2 else fEast:=1 else fEast:=0;
  if Pos(MudMapperForm.sWest,fExits)>0 then if Pos('('+MudMapperForm.sWest+')',fExits)>0 then fWest:=2 else fWest:=1 else fWest:=0;
  if Pos(MudMapperForm.sNorth,fExits)>0 then if Pos('('+MudMapperForm.sNorth+')',fExits)>0 then fNorth:=2 else fNorth:=1 else fNorth:=0;
  if Pos(MudMapperForm.sSouth,fExits)>0 then if Pos('('+MudMapperForm.sSouth+')',fExits)>0 then fSouth:=2 else fSouth:=1 else fSouth:=0;
  if Pos(MudMapperForm.sUp,fExits)>0 then if Pos('('+MudMapperForm.sUp+')',fExits)>0 then fUp:=2 else fUp:=1 else fUp:=0;
  if Pos(MudMapperForm.sDown,fExits)>0 then if Pos('('+MudMapperForm.sDown+')',fExits)>0 then fDown:=2 else fDown:=1 else fDown:=0;
end;

procedure TMudRoom2.PaintSelf(Canvas:TCanvas);
var xX,xY,xL,i,j,ht:Integer;
    S1:String;
    AP:Array [0..11] of integer;
    ILSkin,ILIcons:TImageList;
begin
  if MudMapperForm.cbSkins.ItemIndex=0
  then begin
    ILSkin:=MudMapperForm.ImageListSkin;
    ILIcons:=MudMapperForm.ImageListSkinIcons;
  end else begin
    ILSkin:=MudMapperForm.ImageListSkin2;
    ILIcons:=MudMapperForm.ImageListSkinIcons2;
  end;
  ht:=ILSkin.Height;
  ILSkin.BkColor:=clNone;
  xL:=Trunc(ht/8)*(fDL-fL);
  xX:=(TBitmapPanel(Owner).Clientheight) div 2-(ht div 2)+(fx-fdx)*ht+xL;
  xY:=(TBitmapPanel(Owner).Clientwidth) div 2-(ht div 2)+(fy-fdy)*ht+xL;
  if (xX>-ht)and(xX<(TBitmapPanel(Owner).Clientheight))and(xY>-ht)and(xY<(TBitmapPanel(Owner).Clientwidth))
  then begin
    ILSkin.DrawingStyle:=dsTransparent;
    if fL=fDL
    then begin
      ILSkin.DrawingStyle:=dsTransparent;
    end else if fL+1=fDL
    then begin
      ILSkin.BlendColor:=clBlack;//clGray;
      ILSkin.DrawingStyle:=dsFocus;
    end else begin
      ILSkin.BlendColor:=clBlack;
      ILSkin.DrawingStyle:=dsFocus;
    end;
    if fPipe Then
    Begin
      if (fNorth>0)or(ChN)or(fSouth>0)or(ChS) then //  - 
      begin
        if fL-fDl<1 then ILSkin.Draw(Canvas,xY,xX,50);
        if fL-fDL=1 then ILSkin.Draw(Canvas,xY,xX,102);
      end else begin
        if fL-fDl<1 then ILSkin.Draw(Canvas,xY,xX,51);
        if fL-fDL=1 then ILSkin.Draw(Canvas,xY,xX,103);
      end;
    end else begin
      AP[0]:=iif(fChN,3,0)+fNorth;
      AP[1]:=iif(fChS,3,0)+fSouth;
      AP[2]:=iif(fChW,3,0)+fWest;
      AP[3]:=iif(fChE,3,0)+fEast;
      AP[4]:=iif(fChU,3,0)+fUp;
      AP[5]:=iif(fChD,3,0)+fDown;
      AP[6]:=0;
      AP[7]:=0;
      AP[8]:=0;
      AP[9]:=0;
      AP[10]:=0;
      AP[11]:=0;
      For i:=0 to AutoMaps.Count-1 Do
      begin
        j:=MudMapperForm.DirList.IndexOf(Token(2,Automaps.Strings[i],'|'));
        if j>-1 then AP[6+j]:=iif(Token(1,Automaps.Strings[i],'|')<>'',1,0)+iif(Token(4,Automaps.Strings[i],'|')<>'',2,0);
      end;
      if fL-fDl<1 then
      begin
//        S1:='Room #'+IntToStr(Tag)+'  ';
//        For i:=0 to 11 Do S1:=S1+IntToStr(AP[i]);
//        MudMapperForm.DLine(S1);

        ILSkin.Draw(Canvas,xY,xX,0);
        Canvas.Brush.Color:=fBColor;
        ILSkin.Draw(Canvas,xY,xX,4+AP[4]*6+2);
        ILSkin.Draw(Canvas,xY,xX,5+AP[5]*6+2);
        if fL=fDl then Canvas.FloodFill(xY+MudMapperForm.CurrFillPoint.X,xX+MudMapperForm.CurrFillPoint.Y,Canvas.Pixels[xY+MudMapperForm.CurrFillPoint.X,xX+MudMapperForm.CurrFillPoint.Y],fsSurface);
        ILSkin.Draw(Canvas,xY,xX,1);
        for j:=0 to 3 Do ILSkin.Draw(Canvas,xY,xX,j+AP[j]*6+2);
        for j:=6 to 11 Do
        begin
          if (AP[j]=3)or(AP[j]=1)
          then ILSkin.Draw(Canvas,xY,xX,j+38);
          if (AP[j]=3)or(AP[j]=2)
          then ILSkin.Draw(Canvas,xY,xX,j+32);
        end;
      end else if fL-fDL=1 then
      begin
        //  
        ILSkin.Draw(Canvas,xY,xX,53);
        for j:=0 to 5 Do ILSkin.Draw(Canvas,xY,xX,j+AP[j]*6+54);
        if (AP[j]=3)or(AP[j]=1) then ILSkin.Draw(Canvas,xY,xX,j+38+52);
        if (AP[j]=3)or(AP[j]=2) then ILSkin.Draw(Canvas,xY,xX,j+32+52);
      end;

    end;

    if (fL=fDl)and(Hint=MudMapperForm.sDark) then
    begin
      ILIcons.DrawingStyle:=dsTransparent;
      ILIcons.Draw(Canvas,xY+1+(ht div 4),xX+1+(ht div 4),0);
    end;
    if (ImageIndex>0) then
    begin
      if fL=fDL
      then begin
        ILIcons.DrawingStyle:=dsTransparent;
        ILIcons.Draw(Canvas,xY+MudMapperForm.CurrPicPoint.Y,xX+MudMapperForm.CurrPicPoint.X,ImageIndex);
      end else if fL+1=fDL
      then begin
        ILIcons.BlendColor:=clGray;
        ILIcons.DrawingStyle:=dsFocus;
        ILIcons.Draw(Canvas,xY+MudMapperForm.CurrPicPoint.Y,xX+MudMapperForm.CurrPicPoint.X,ImageIndex);
      end else if fL<fDL
      then begin
        ILIcons.BlendColor:=clBlack;
        ILIcons.DrawingStyle:=dsFocus;
        ILIcons.Draw(Canvas,xY+MudMapperForm.CurrPicPoint.Y,xX+MudMapperForm.CurrPicPoint.X,ImageIndex);
      end;
    end;

//    MudMapperForm.DLine('PaintSelf:(3) draw Selected/Checked bounds');
    if fSelected then ILSkin.Draw(Canvas,xY,xX,104);
    if fChecked then ILSkin.Draw(Canvas,xY,xX,105);
  end;
//  MudMapperForm.DLine('PaintSelf:(4) end');
end;

end.
