unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ComCtrls, Registry, Buttons;

type
  TSaveLoadForm = class(TForm)
    ListView1: TListView;
    ButtonOk: TButton;
    ButtonCancel: TButton;
    lblName: TLabel;
    WorldName: TEdit;
    PopupMenu1: TPopupMenu;
    nSelect: TMenuItem;
    N1: TMenuItem;
    nDelete: TMenuItem;
    nRename: TMenuItem;
    ImageList1: TImageList;
    ImageList2: TImageList;
    N2: TMenuItem;
    nView: TMenuItem;
    nIcons: TMenuItem;
    nList: TMenuItem;
    procedure nSelectClick(Sender: TObject);
    procedure nRenameClick(Sender: TObject);
    procedure ListView1DblClick(Sender: TObject);
    procedure ListView1Click(Sender: TObject);
    procedure WorldNameChange(Sender: TObject);
    procedure ListView1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    function DeleteWorld(s:String):Boolean;
    procedure nDeleteClick(Sender: TObject);
    procedure nIconsClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure SetMode(Mode,wName:String);
  end;

var
  SaveLoadForm: TSaveLoadForm;
  RootName:String;


implementation

uses Unit1;

{$R *.DFM}

procedure TSaveLoadForm.SetMode(Mode,wName:String);
Var DosError:Integer;
    SearchRec:TSearchRec;
begin
  if MudMapperForm.ListViewStyle=1
  then NIconsClick(NIcons)
  Else NIconsClick(NList);
  WorldName.Text:=wName;
  RootName:=ExtractFilePath(Application.ExeName)+'Maps';
  ListView1.Items.Clear;
  DosError := FindFirst(RootName+'\*.*', faDirectory, SearchRec);
  while DosError = 0 do
  begin
    if (SearchRec.Attr and faDirectory = faDirectory) and (SearchRec.Name[1] <> '.')
    then With ListView1.Items.Add Do
    begin
      Caption:=SearchRec.Name;
      ImageIndex:=0;
    end;
    DosError := FindNext(SearchRec);
  end;
  if Mode='Load' then
  begin
    Self.Caption:=' ...';
    Self.Caption:=MudMapperForm.GetCaption('SaveLoadForm','LoadCaption',Self.Caption);
    WorldName.Text:='';
    ButtonOk.Enabled:=False;
    ButtonOk.Caption:='';
    ButtonOk.Caption:=MudMapperForm.GetCaption('SaveLoadForm','btnOkLoad',ButtonOk.Caption);
  end else if Mode='Save' then
  begin
    Self.Caption:='  ...';
    Self.Caption:=MudMapperForm.GetCaption('SaveLoadForm','SaveAsCaption',Self.Caption);
    ButtonOk.Caption:='';
    ButtonOk.Caption:=MudMapperForm.GetCaption('SaveLoadForm','btnOkSave',ButtonOk.Caption);
    ButtonOk.Enabled:=True;
  end else if Mode='Create' then
  begin
    Caption:='  ...';
    Self.Caption:=MudMapperForm.GetCaption('SaveLoadForm','NewCaption',Self.Caption);
    ButtonOk.Caption:='';
    ButtonOk.Caption:=MudMapperForm.GetCaption('SaveLoadForm','btnOkNew',ButtonOk.Caption);
    ButtonOk.Enabled:=True;
  end;
end;

procedure TSaveLoadForm.nSelectClick(Sender: TObject);
begin
     ModalResult:=mrOk;
end;

procedure TSaveLoadForm.nRenameClick(Sender: TObject);
begin
     ListView1.Selected.EditCaption;
end;

procedure TSaveLoadForm.ListView1DblClick(Sender: TObject);
begin
     if ListView1.SelCount>0 then nSelectClick(Self);
end;

procedure TSaveLoadForm.ListView1Click(Sender: TObject);
begin
     if ListView1.SelCount>0 then WorldName.Text:=ListView1.Selected.Caption;
end;

procedure TSaveLoadForm.WorldNameChange(Sender: TObject);
begin
  ButtonOk.Enabled:=(WorldName.Text<>'');
  nSelect.Enabled:=ButtonOk.Enabled;
end;

procedure TSaveLoadForm.ListView1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
Var P:TPoint;
begin
  if ListView1.SelCount>0 then
  begin
    WorldName.Text:=ListView1.Selected.Caption;
    P:=ListView1.ClientToScreen(Point(x,y));
    if Button=mbRight Then PopupMenu1.Popup(P.X,P.Y);
  end;
end;

function TSaveLoadForm.DeleteWorld(s:String):Boolean;
var DosError:Integer;
    SearchRec:TSearchRec;
    RootName:String;
begin
  RootName:=ExtractFilePath(Application.ExeName)+'Maps\'+s;
  DosError := FindFirst(RootName+'\*.map', faAnyFile, SearchRec);
  while DosError = 0 do
  begin
    if not(SearchRec.Attr and faDirectory = faDirectory)
    then begin
      DeleteFile(RootName+'\'+SearchRec.Name);
    end;
    DosError := FindNext(SearchRec);
  end;
  Result:=RemoveDir(RootName);
end;

procedure TSaveLoadForm.nDeleteClick(Sender: TObject);
Var S:String;
begin
   S:=MudMapperForm.GetCaption('SaveLoadForm','DeleteMessage',' ,    ');
   if ListView1.SelCount>0 then
   if Application.MessageBox(PChar(S+' <'+WorldName.Text+'>?'),
      'Mud Maper',MB_YESNO+MB_ICONQUESTION)=ID_YES Then
   begin
     if DeleteWorld(WorldName.Text) then
     begin
       ListView1.Items.Delete(ListView1.Selected.Index);
       ListView1.Arrange(arDefault);
     end;
   end;
end;

procedure TSaveLoadForm.nIconsClick(Sender: TObject);
begin
  TMenuItem(Sender).Checked:=True;
  if NIcons.Checked Then ListView1.ViewStyle:=vsIcon else ListView1.ViewStyle:=vsList;
  if NIcons.Checked then MudMapperForm.ListViewStyle:=1 else MudMapperForm.ListViewStyle:=2;
end;

procedure TSaveLoadForm.FormCreate(Sender: TObject);
begin
  lblName.Caption:=MudMapperForm.GetCaption('SaveLoadForm','lblName',lblName.Caption);
  ButtonCancel.Caption:=MudMapperForm.GetCaption('SaveLoadForm','ButtonCancel',ButtonCancel.Caption);
  nSelect.Caption:=MudMapperForm.GetCaption('SaveLoadForm','nSelect',nSelect.Caption);
  nView.Caption:=MudMapperForm.GetCaption('SaveLoadForm','nView',nView.Caption);
  nIcons.Caption:=MudMapperForm.GetCaption('SaveLoadForm','nIcons',nIcons.Caption);
  nList.Caption:=MudMapperForm.GetCaption('SaveLoadForm','nList',nList.Caption);
  nRename.Caption:=MudMapperForm.GetCaption('SaveLoadForm','nRename',nRename.Caption);
  nDelete.Caption:=MudMapperForm.GetCaption('SaveLoadForm','nDelete',nDelete.Caption);
end;

end.
