unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, CustomColorBox, ExtCtrls, MudRoom, Menus, Unit5,
  BitmapPanel;

type
  TPropertyForm = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    EditName: TEdit;
    lblName: TLabel;
    lblDescription: TLabel;
    RoomDescr: TMemo;
    lblExits: TLabel;
    EditExits: TEdit;
    lblChecked: TLabel;
    EditChExits: TEdit;
    lblNote: TLabel;
    RoomNote: TMemo;
    AutomapList: TListView;
    lblAutomap: TLabel;
    ImageList1: TImageList;
    PopupMenu1: TPopupMenu;
    NAdd: TMenuItem;
    NEdit: TMenuItem;
    NDel: TMenuItem;
    btnOk: TButton;
    btnCancel: TButton;
    btnColor: TButton;
    Panel2: TPanel;
    cbDT: TCheckBox;
    cbAgro: TCheckBox;
    lblWarning: TLabel;
    cbFlyDT: TCheckBox;
    cbNoStep: TCheckBox;
    ComboBox1: TComboBox;
    lblPicture: TLabel;
    Panel1: TBitmapPanel;
    lblAlias: TLabel;
    EditAlias: TEdit;
//    Room:TMudRoom;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure EditExitsChange(Sender: TObject);
    procedure EditChExitsChange(Sender: TObject);
    procedure RoomDescrChange(Sender: TObject);
    procedure EditNameChange(Sender: TObject);
    procedure RoomNoteChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure NAddClick(Sender: TObject);
    procedure NEditClick(Sender: TObject);
    procedure NDelClick(Sender: TObject);
    procedure btnColorClick(Sender: TObject);
    procedure cbPropClick(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure Panel1Paint(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Room:TMudRoom2;
  end;

var
  PropertyForm: TPropertyForm;

implementation

{$R *.DFM}

uses Unit1;

function iif(Cond:Boolean; X:Variant; Y:Variant):Variant;
begin
  if Cond then Result:=X else Result:=y;
end;

procedure TPropertyForm.FormCreate(Sender: TObject);
var i:Integer;
begin
  Self.Caption:=MudMapperForm.GetCaption('PropertyForm','Caption',Self.Caption);
  TabSheet1.Caption:=MudMapperForm.GetCaption('PropertyForm','TabSheet1',TabSheet1.Caption);
  TabSheet2.Caption:=MudMapperForm.GetCaption('PropertyForm','TabSheet2',TabSheet2.Caption);
  lblName.Caption:=MudMapperForm.GetCaption('PropertyForm','lblName',lblName.Caption);
  lblDescription.Caption:=MudMapperForm.GetCaption('PropertyForm','lblDescription',lblDescription.Caption);
  lblAlias.Caption:=MudMapperForm.GetCaption('PropertyForm','lblAlias',lblAlias.Caption);
  lblExits.Caption:=MudMapperForm.GetCaption('PropertyForm','lblExits',lblExits.Caption);
  lblChecked.Caption:=MudMapperForm.GetCaption('PropertyForm','lblChecked',lblChecked.Caption);
  cbDT.Caption:=MudMapperForm.GetCaption('PropertyForm','cbDT',cbDT.Caption);
  cbFlyDT.Caption:=MudMapperForm.GetCaption('PropertyForm','cbFlyDT',cbFlyDT.Caption);
  cbAgro.Caption:=MudMapperForm.GetCaption('PropertyForm','cbAgro',cbAgro.Caption);
  cbNoStep.Caption:=MudMapperForm.GetCaption('PropertyForm','cbNoStep',cbNoStep.Caption);
  btnColor.Caption:=MudMapperForm.GetCaption('PropertyForm','btnColor',btnColor.Caption);
  lblPicture.Caption:=MudMapperForm.GetCaption('PropertyForm','lblPicture',lblPicture.Caption);
  lblNote.Caption:=MudMapperForm.GetCaption('PropertyForm','lblNote',lblNote.Caption);
  lblAutomap.Caption:=MudMapperForm.GetCaption('PropertyForm','lblAutomap',lblAutomap.Caption);
  lblWarning.Caption:=MudMapperForm.GetCaption('PropertyForm','lblWarning',lblWarning.Caption);
  AutomapList.Columns.Items[0].Caption:=MudMapperForm.GetCaption('PropertyForm','AuomapColumn1',AutomapList.Columns.Items[0].Caption);
  AutomapList.Columns.Items[1].Caption:=MudMapperForm.GetCaption('PropertyForm','AuomapColumn2',AutomapList.Columns.Items[1].Caption);
  btnOk.Caption:=MudMapperForm.GetCaption('PropertyForm','btnOk',btnOk.Caption);
  btnCancel.Caption:=MudMapperForm.GetCaption('PropertyForm','btnCancel',btnCancel.Caption);

  Room:=TMudRoom2.Create(Panel1);
  Room.BColor:=clSilver;
  Room.X:=0;
  Room.Y:=0;
  Room.DX:=0;
  Room.DY:=0;
  Room.Selected:=True;
//---  Room.ImageList:=TImageList.CreateSize(32,32);
  For i:=0 to MudMapperForm.ImageListSkinIcons.Count-1 Do ComboBox1.Items.Add(' ');
end;

procedure TPropertyForm.FormDestroy(Sender: TObject);
begin
  Room.Destroy;
end;

procedure TPropertyForm.EditExitsChange(Sender: TObject);
begin
   Room.Exits:=EditExits.Text;
   Panel1.Repaint;
end;

procedure TPropertyForm.EditChExitsChange(Sender: TObject);
begin
   With EditChExits Do
   begin
     Room.ChN:=(Pos('N',Text)>0);
     Room.ChS:=(Pos('S',Text)>0);
     Room.ChE:=(Pos('E',Text)>0);
     Room.ChW:=(Pos('W',Text)>0);
     Room.ChD:=(Pos('D',Text)>0);
     Room.ChU:=(Pos('U',Text)>0);
   End;
   Panel1.Repaint;
end;

procedure TPropertyForm.RoomDescrChange(Sender: TObject);
begin
  Room.Description:=RoomDescr.Text;
end;

procedure TPropertyForm.EditNameChange(Sender: TObject);
begin
     Room.Hint:=EditName.Text;
end;

procedure TPropertyForm.RoomNoteChange(Sender: TObject);
begin
  Room.Note:=RoomNote.Text;
end;

procedure TPropertyForm.FormShow(Sender: TObject);
begin
  PageControl1.ActivePage:=PageControl1.Pages[0];
  MudMapperForm.ImageListSkinIcons.DrawingStyle:=dsTransparent;
end;

procedure TPropertyForm.NAddClick(Sender: TObject);
var fRoom:TMudRoom2;
    S1,S2:String;
begin
  Application.CreateForm(TAutomapForm, AutomapForm);
  AutomapForm.ComboBoxExit.Text:='';
  AutomapForm.EditSendTrigger.Text:='';
  AutomapForm.ComboBoxMap.Text:='';
  AutomapForm.EditX.Text:='0';
  AutomapForm.ComboBoxExitChange(Self);
  if (AutomapForm.ShowModal=mrOk) then
  begin
    S1:=MudMapperForm.GetCaption('PropertyForm','NotFoundInZone','   ');
    S2:=MudMapperForm.GetCaption('PropertyForm','RoomNumber',' #');
    fRoom:=MudMapperForm.GlobalFindRoomByTag(StrToInt(AutomapForm.EditX.Text),AutomapForm.ComboBoxMap.Text);
    if (fRoom<>Nil)or(StrToInt(AutomapForm.EditX.Text)<1) then
    begin
      With AutomapList.Items.Add() Do
      begin
        Caption:=AutomapForm.ComboBoxMap.Text;
        ImageIndex:=0;
        SubItems.Add(AutomapForm.ComboBoxExit.Text);
        SubItems.Add(AutomapForm.EditX.Text);
        SubItems.Add(AutomapForm.EditSendTrigger.Text);
        MudMapperForm.SetCheck(Room,SubItems.Strings[0],True);
        MudMapperForm.SetCheck(MudMapperForm.SelectedRoom,SubItems.Strings[0],True);
        Room.AutoMaps.Add(Caption+'|'+SubItems.Strings[0]+'|'+AutomapForm.EditX.Text+'|'+AutomapForm.EditSendTrigger.Text);
        MudMapperForm.SelectedRoom.AutoMaps.Add(Caption+'|'+SubItems.Strings[0]+'|'+AutomapForm.EditX.Text+'|'+AutomapForm.EditSendTrigger.Text);
        With Room Do EditChExits.Text:=iif(ChN,'N','')+iif(ChS,'S','')+iif(ChE,'E','')+iif(ChW,'W','')+iif(ChU,'U','')+iif(ChD,'D','');
        if (StrToInt(AutomapForm.EditX.Text)>0)
        then fRoom:=MudMapperForm.GlobalFindRoomByTag(StrToInt(AutomapForm.EditX.Text),Caption)
        else fRoom:=Nil;
        S1:=MudMapperForm.GetCaption('PropertyForm','SetNewOppositeLink','     ');
        if fRoom<>Nil
        Then if Application.MessageBox(PChar(S1+' <'+Caption+'>, '+S2+SubItems.Strings[1]+'?'),
             PChar(fProductName),MB_ICONQUESTION+MB_YESNOCANCEL+MB_SYSTEMMODAL)=ID_YES
            then begin
              fRoom.AutoMaps.Add(MudMapperForm.ZoneName+'|'+MudMapperForm.Opposite(SubItems.Strings[0])+'|'+IntToStr(MudMapperForm.SelectedRoom.Tag));
              MudMapperForm.SetCheck(fRoom,MudMapperForm.Opposite(SubItems.Strings[0]),True);
            end;
      end;
    end else Application.MessageBox(PChar(S2+AutomapForm.EditX.Text+' '+S1+' <'+AutomapForm.ComboBoxMap.Text+'>.'),
             PChar(fProductName),MB_ICONSTOP+MB_OK+MB_SYSTEMMODAL);
  end;
  AutomapForm.Free;
end;

procedure TPropertyForm.NEditClick(Sender: TObject);
var fRoom:TMudRoom2;
    i,n:Integer;
    S1,S2:String;
begin
  if AutomapList.SelCount>0 then
  With AutomapList.Selected Do
  begin
    Application.CreateForm(TAutomapForm, AutomapForm);
    AutomapForm.ComboBoxMap.Text:=Caption;
    AutomapForm.EditSendTrigger.Text:=Subitems.Strings[2];
    AutomapForm.ComboBoxExit.Text:=Subitems.Strings[0];
    AutomapForm.ComboBoxExitChange(Self);
    AutomapForm.EditX.Text:=Subitems.Strings[1];
    if (AutomapForm.ShowModal=mrOk) then
    begin
      S1:=MudMapperForm.GetCaption('PropertyForm','NotFoundInZone','   ');
      S2:=MudMapperForm.GetCaption('PropertyForm','RoomNumber',' #');
      fRoom:=MudMapperForm.GlobalFindRoomByTag(StrToInt(AutomapForm.EditX.Text),AutomapForm.ComboBoxMap.Text);
      if (fRoom<>Nil)or(StrToInt(AutomapForm.EditX.Text)<1) Then
      begin
        if (StrToInt(AutomapForm.EditX.Text)>0)and(AutomapForm.ComboBoxMap.Text<>'')
        then fRoom:=MudMapperForm.GlobalFindRoomByTag(StrToInt(AutomapForm.EditX.Text),Caption)
        else fRoom:=Nil;
        if fRoom<>Nil Then
        begin
          n:=-1;
          i:=0;
          S1:=MudMapperForm.GetCaption('PropertyForm','DeleteOppositeLink','     ');
          while (i<fRoom.AutoMaps.Count)and(n=-1) Do
          if fRoom.AutoMaps[i]=MudMapperForm.ZoneName+'|'+MudMapperForm.Opposite(SubItems.Strings[0])+'|'+IntToStr(MudMapperForm.SelectedRoom.Tag)
          then n:=i else inc(i);
          if (n>-1) then
          if Application.MessageBox(PChar(S1+' <'+Caption+'>, '+S2+SubItems.Strings[1]+'?'),
             PChar(fProductName),MB_ICONQUESTION+MB_YESNOCANCEL+MB_SYSTEMMODAL)=ID_YES Then
          begin
            fRoom.AutoMaps.Delete(n);
            MudMapperForm.SetCheck(fRoom,MudMapperForm.Opposite(SubItems.Strings[0]),False);
          end;
        end;
        n:=-1;
        i:=0;
        while (i<Room.AutoMaps.Count)and(n=-1) Do
        if Room.AutoMaps[i]=Caption+'|'+SubItems.Strings[0]+'|'+SubItems.Strings[1]+'|'+SubItems.Strings[2]
        then n:=i;
        Caption:=AutomapForm.ComboBoxMap.Text;
        ImageIndex:=0;
        MudMapperForm.SetCheck(Room,SubItems.Strings[0],False);
        MudMapperForm.SetCheck(MudMapperForm.SelectedRoom,SubItems.Strings[0],False);
        SubItems.Strings[0]:=AutomapForm.ComboBoxExit.Text;
        SubItems.Strings[1]:=AutomapForm.EditX.Text;
        MudMapperForm.SetCheck(Room,SubItems.Strings[0],True);
        MudMapperForm.SetCheck(MudMapperForm.SelectedRoom,SubItems.Strings[0],True);
        if (n>-1) then
        begin
          Room.AutoMaps[i]:=Caption+'|'+SubItems.Strings[0]+'|'+SubItems.Strings[1]+'|'+SubItems.Strings[2];
          MudMapperForm.SelectedRoom.AutoMaps[i]:=Caption+'|'+SubItems.Strings[0]+'|'+SubItems.Strings[1]+'|'+SubItems.Strings[2];
        end;
        With Room Do EditChExits.Text:=iif(ChN,'N','')+iif(ChS,'S','')+iif(ChE,'E','')+iif(ChW,'W','')+iif(ChU,'U','')+iif(ChD,'D','');
        fRoom:=MudMapperForm.GlobalFindRoomByTag(StrToInt(Subitems.Strings[1]),Caption);
        S1:=MudMapperForm.GetCaption('PropertyForm','SetNewOppositeLink','     ');
        S2:=MudMapperForm.GetCaption('PropertyForm','RoomNumber',' #');
        if fRoom<>Nil
        Then if Application.MessageBox(PChar(S1+' <'+Caption+'>, '+S2+SubItems.Strings[1]+'?'),
             PChar(fProductName),MB_ICONQUESTION+MB_YESNOCANCEL+MB_SYSTEMMODAL)=ID_YES
        then begin
          fRoom.AutoMaps.Add(MudMapperForm.ZoneName+'|'+MudMapperForm.Opposite(SubItems.Strings[0])+'|'+IntToStr(MudMapperForm.SelectedRoom.Tag));
          MudMapperForm.SetCheck(fRoom,MudMapperForm.Opposite(SubItems.Strings[0]),True);
        end
      end else Application.MessageBox(PChar(S2+AutomapForm.EditX.Text+' '+S1+' <'+AutomapForm.ComboBoxMap.Text+'>.'),
             PChar(fProductName),MB_ICONSTOP+MB_OK+MB_SYSTEMMODAL);
    end;
    if AutomapForm.EditSendTrigger.Text<>'' then

    AutomapForm.Free;
  end else NAddClick(Self);
end;

procedure TPropertyForm.NDelClick(Sender: TObject);
var fRoom:TMudRoom2;
    i,n:Integer;
    S1,S2:String;
begin
  if AutomapList.SelCount>0 then
  begin
    S1:=MudMapperForm.GetCaption('PropertyForm','DeleteLink','   ');
    S2:=MudMapperForm.GetCaption('PropertyForm','RoomNumber',' #');
    if Application.MessageBox(PChar(S1+' <'+AutomapList.Selected.caption+'>?'),'Mud Maper',MB_YESNO+MB_ICONQUESTION)=ID_YES then
    with AutomapList.Selected do
    begin
      fRoom:=MudMapperForm.GlobalFindRoomByTag(StrToInt(SubItems.Strings[1]),Caption);
      if fRoom<>Nil then
      begin
        n:=-1;
        i:=0;
        while (i<fRoom.AutoMaps.Count)and(n=-1) Do
        begin
          if Pos(MudMapperForm.ZoneName+'|'+MudMapperForm.Opposite(SubItems.Strings[0])+'|'+IntToStr(MudMapperForm.SelectedRoom.Tag),fRoom.AutoMaps[i])=1
          then n:=i;
          inc(i);
        end;
        S1:=MudMapperForm.GetCaption('PropertyForm','DeleteOppositeLink','     ');
        if (n>-1) then
        if Application.MessageBox(PChar(S1+' <'+Caption+'>, '+S2+SubItems.Strings[1]+'?'),
           PChar(fProductName),MB_ICONQUESTION+MB_YESNOCANCEL+MB_SYSTEMMODAL)=ID_YES Then
        begin
          fRoom.AutoMaps.Delete(n);
          MudMapperForm.SetCheck(fRoom,MudMapperForm.Opposite(SubItems.Strings[0]),False);
        end;
      end;
      MudMapperForm.SetCheck(Room,SubItems[0],False);
      MudMapperForm.SetCheck(MudMapperForm.SelectedRoom,SubItems.Strings[0],False);
      With Room Do EditChExits.Text:=iif(ChN,'N','')+iif(ChS,'S','')+iif(ChE,'E','')+iif(ChW,'W','')+iif(ChU,'U','')+iif(ChD,'D','');
      Room.AutoMaps.Delete(AutomapList.Items.IndexOf(AutomapList.Selected));
      MudMapperForm.SelectedRoom.AutoMaps.Delete(AutomapList.Items.IndexOf(AutomapList.Selected));
      AutomapList.Items.Delete(AutomapList.Items.IndexOf(AutomapList.Selected));
    end;
  end;
end;

procedure TPropertyForm.btnColorClick(Sender: TObject);
begin
  MudMapperForm.ColorDialog1.Color:=Room.BColor;
  if MudMapperForm.ColorDialog1.Execute then Room.BColor:=MudMapperForm.ColorDialog1.Color;
  Panel1.Repaint;
end;

procedure TPropertyForm.cbPropClick(Sender: TObject);
begin
  if Tag=0 then
  begin
    Tag:=1;
    ComboBox1.ItemIndex:=0;
    if TCheckBox(Sender).Checked then
    begin
      cbDt.Checked:=False;
      cbFlyDt.Checked:=False;
      cbAgro.Checked:=False;
      cbNoStep.Checked:=False;
      TCheckBox(Sender).Checked:=True;
      ComboBox1.ItemIndex:=TCheckBox(Sender).tag;
      ComboBox1.Repaint;
    end;
    Room.DT:=cbDt.Checked;
    Room.FlyDT:=cbFlyDt.Checked;
    Room.Agro:=cbAgro.Checked;
    Room.NoStep:=cbNoStep.Checked;
    ComboBox1Change(Self);
    Tag:=0;
    Panel1.Repaint;
  end;
end;

procedure TPropertyForm.ComboBox1Change(Sender: TObject);
begin
  Room.ImageIndex:=ComboBox1.ItemIndex;
  if (Tag=0) then
  begin
    Case ComboBox1.ItemIndex Of
    1: begin cbDT.Checked:=True; cbPropClick(cbDT); end;
    2: begin cbFlyDT.Checked:=True; cbPropClick(cbFlyDT); end;
    3: begin cbAgro.Checked:=True; cbPropClick(cbAgro); end;
    4: begin cbNoStep.Checked:=True; cbPropClick(cbNoStep); end;
    Else begin
         Tag:=1;
         cbDT.Checked:=False;
         cbFlyDT.Checked:=False;
         cbAgro.Checked:=False;
         cbNoStep.Checked:=False;
         Room.DT:=cbDt.Checked;
         Room.FlyDT:=cbFlyDt.Checked;
         Room.Agro:=cbAgro.Checked;
         Room.NoStep:=cbNoStep.Checked;
       end;
    End;
    Tag:=0;
    Panel1.Repaint;
  end;
end;

procedure TPropertyForm.ComboBox1DrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  ComboBox1.Canvas.Brush.Color:=clWindow;
  ComboBox1.Canvas.FillRect(Rect);
  ComboBox1.Canvas.Brush.Color:=clHighlight;
  if odSelected in State then ComboBox1.Canvas.FillRect(Rect);
  if odFocused in State then ComboBox1.Canvas.DrawFocusRect(Rect);
  if Index>0 then MudMapperForm.ImageListSkinIcons.Draw(ComboBox1.Canvas,Rect.Left,Rect.Top,Index);
end;

procedure TPropertyForm.Panel1Paint(Sender: TObject);
var i,j:Integer;
begin
  Panel1.Canvas.Brush.Color:=Panel1.Color;
  if Panel1.ImageIndex=-1 then Panel1.Canvas.FillRect(Panel1.ClientRect)
  Else begin
    for i:=0 to Panel1.ClientHeight div 64 Do
      for j:=0 to Panel1.ClientWidth div 64 Do
        MudmapperForm.ImageList4.Draw(Panel1.Canvas,j*64,i*64,Panel1.ImageIndex);
  end;
  Room.PaintSelf(Panel1.Canvas);
end;

end.
